<?php
/**
 * Plugin Name: My Contact
 * Description: Simple contact form, powered by AngularJS
 * Version: 1.0-development
 * Plugin URI: http://iehsan.ir/blog/
 * Author: Ehsaan
 * Author URI: http://iehsan.ir/
 */

class My_Contact {
	public function __construct() {
		add_shortcode( 'my-contact', array( $this, 'render' ) );
		add_action( 'wp_enqueue_scripts', array( $this, 'register_scripts' ), 1 );
		add_action( 'wp_enqueue_scripts', array( $this, 'enqueue' ), 2 );

		add_action( 'init', array( $this, 'process' ), 100 );
	}

	public function render() {
		ob_start();
		?>
		<form method="POST" name="contact-form" ng-app="FormApp" ng-controller="Form as form" ng-submit="form.doSubmit()">
			<p class="sending-info" ng-show="form.sending == true">در حال ارسال . . .</p>
			<p class="completed-info" ng-show="form.sent == true">ممنون، اطلاعات ارسال شد!</p>
			<p class="error-info" ng-show="form.errored == true">شرمنده، فرم ارسال نشد، اینترنته دیگه.</p>

			<p class="comment-form-author">
				<label for="name">نام شما <span class="required">*</span></label>
				<input id="name" ng-model="form.formData.name" name="name" size="30" aria-required="true" type="text" required>
			</p>
			<p class="comment-form-email">
				<label for="email">ایمیل شما <span class="required">*</span></label>
				<input id="email" ng-model="form.formData.email" name="email" size="30" aria-required="true" type="email" required>
			</p>
			<p class="comment-form-comment">
				<label for="comment">چی میخواید بگید؟ <span class="required">*</span></label>
				<textarea id="comment" ng-model="form.formData.comment" name="comment" cols="45" rows="8" required aria-required="true"></textarea>
			</p>
			<p class="form-submit">
				<button type="submit" name="submit" id="submit">ارسال</button>
			</p>
		</form>
		<?php
		return ob_get_contents();
		ob_end_flush();
	}
	
	public function register_scripts() {
		wp_register_script( 'angularjs', plugins_url( 'my-contact/assets/angular.min.js' ) );
		wp_register_script( 'contact-app', plugins_url( 'my-contact/assets/app.js' ), array( 'angularjs' ) );
	}

	public function enqueue() {
		if ( is_page( 'sample-page' ) )
			wp_enqueue_script( 'contact-app' );
	}
	...
	public function process() {
		if ( @ $_GET['sent'] == 'ok' ) {
			header( 'Content-Type: application/json;charset=utf-8' );

			$content = file_get_contents( 'php://input' );
			$data = json_decode( $content, true );

			if ( isset( $data['name'] ) && isset( $data['email'] ) && isset( $data['comment'] ) ) {
				$content = '
					Mr./Mrs. ' . $data['name'] . ' (' . $data['email'] . ') wrote for you:<br>' . $data['comment'] . '<br><hr>End!
				';
				$headers = "Content-Type: text/html;charset=utf-8\nReply-To: " . $data['email'];

				if ( mail( get_bloginfo( 'admin_email' ), 'Contact!', $content, $headers ) ) {
					echo json_encode( array( 'status' => 200 ) );
				} else {
					echo json_encode( array( 'status'	=> 500 ) );
				}
				exit;
			}
		}
	}
	...
}

new My_Contact();
